import 'dart:io';
import './ion_mime.dart';
import './ion_renderer.dart';

class IonResponse {
  final HttpResponse o;

  IonResponse(this.o) {}

  send(data) {
    if (data is File) {
      var str = data.readAsBytesSync();
      o.headers.contentType = ion_mime(data.path);
      o.add(str);
    } else {
      o.write(data);
    }
  }

  setCookie(name, val) {
    o.headers.set("Set-Cookie", "$name = $val");
  }

  deleteCookie(name) {
    o.headers.set(
        "Set-Cookie", "$name = del; expires=Thu, 01 Jan 1970 00:00:00 GMT");
  }

  redirect(path) {
    print("REDIRECTING TO: $path");
    o.statusCode = 308;
    o.headers.set("Location", "$path");
  }

  render(path, [Map data]) {
    throw Exception("NOT YET IMPLEMENTED");
    
    var f = File(path);
    o.headers.contentType = ContentType("text", "html", charset: "UTF-8");
    IonRenderer(f.readAsStringSync(), data);

  }
}
