let Ion = {
    ws(handler) {
        return new (class {
            constructor(handler) {
                this.behaviours = {};

                this.ws = new WebSocket(`ws://${window.location.host}/ion-ws-connect/${handler}`);
                this.ws.onmessage = msg => {
                    let data = JSON.parse(msg.data);
                    Object.keys(this.behaviours).map((title) => {
                        if(title == data[0]) {
                            this.behaviours[title](data[1]);
                        }
                    });
                }
            }

            on(behaviour, fn) {
                this.behaviours[behaviour] = fn;
            }

            send(title, data) {
                this.ws.send(JSON.stringify([title, data]));
            }

            emit(title, data) {
                this.send(title, data);
            }
        })(handler)
    }
};